"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var interceptor = exports.interceptor = function interceptor(routerHistory, hanlders, cancelHandler) {
  if (!window.__preLocation__) {
    window.__preLocation__ = routerHistory.location;
  }
  var __prePath__ = void 0;
  window.__locationStack__ = [];
  if (routerHistory.listenBefore) {
    routerHistory.listenBefore(function (nextLocation, callback) {
      // 当前url地址
      var pathname = window.__preLocation__.pathname;
      //
      if (__prePath__ === pathname) {
        callback();
        return;
      }
      var nextPathname = nextLocation.pathname;
      if (pathname === nextPathname) {
        callback();
        return;
      }
      if (hanlders[pathname]) {
        hanlders[pathname](window.__preLocation__, nextLocation, callback, function () {
          cancelHandler && cancelHandler(pathname);
          __prePath__ = void 0;
        });
      } else {
        callback();
      }
      __prePath__ = pathname;
    });
  } else if (routerHistory.block) {
    routerHistory.block(function (location, action) {
      window._nextlocation_ = location;
      window.hanlders = hanlders;
      window.action = action;
      window.cancelHandler = cancelHandler;
      return "";
    });
  }
  routerHistory.listen(function (location, action) {
    window.__preLocation__ = location;
    if (action === "PUSH") {
      window.__locationStack__.push(location);
    } else if (action === "POP") {
      window.__locationStack__.pop();
    }
  });
};

var getUserConfirmation = exports.getUserConfirmation = function getUserConfirmation(result, callback) {
  var next = function next() {
    return callback(true);
  };
  var cancel = function cancel() {
    callback(false);
  };
  var parseQuery = function parseQuery(e, t, n) {
    var r = {};
    return n.split(e).forEach(function (e) {
      var n = e.split(t);
      void 0 !== n[0] && void 0 !== n[1] && (r[n[0]] = n[1]);
    }), r;
  };
  var searchstr = window._nextlocation_.search;
  var searchobj = parseQuery("&", "=", searchstr.substr(1, searchstr.length - 1));
  var isignore = false;

  if (searchobj.ignorehander && searchobj.ignorehander === "true") {
    callback(true);
    return;
  }

  //当前页面是一个的时候有问题
  if (window.__preLocation__) {
    var pathname = window.__preLocation__.pathname;
  }

  if (pathname === window._nextlocation_.pathname) {
    // 如果当前地址与目标地址一致 不处理
    callback(false);
    return;
  }

  if (window.hanlders[pathname]) {
    // 如果当前地址需要拦截
    window.hanlders[pathname](window.__locationStack__, location, next, function () {
      cancelHandler && cancelHandler(pathname);
      cancel();
    }, window.action);
  } else {
    next();
  }
};