"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routerHistory, hanlders, cancelHandler) {
  var __prePath__ = void 0;
  routerHistory.listenBefore(function (nextLocation, callback) {
    var pathname = window.__preLocation__.pathname;

    if (__prePath__ === pathname) {
      callback();
      return;
    }
    var nextPathname = nextLocation.pathname;
    if (pathname === nextPathname) {
      callback();
      return;
    }
    if (hanlders[pathname]) {
      hanlders[pathname](window.__preLocation__, nextLocation, callback, function () {
        cancelHandler && cancelHandler(pathname);
        __prePath__ = void 0;
      });
    } else {
      callback();
    }
    __prePath__ = pathname;
  });
  routerHistory.listen(function (location) {
    window.__preLocation__ = location;
  });
};

module.exports = exports["default"];